.586
.model flat, stdcall
.stack 100h

include windows.inc
include kernel32.inc
includelib kernel32.lib

comment /

	Simple example of modifying a text file on disk using FileMapping.
	A sample text file named 'testfile.txt' must be in current directory.

	/
.data

szFilename	db	"testfile.txt", NULL

.code

MapaFile proc

local 	hFile		:dword
local	hMapObject	:dword
local	pMapView	:dword


;============================================================================
;====================================== Open file ===========================
;============================================================================


	;---- open existing file with read/write access
	invoke CreateFile, addr szFilename, GENERIC_READ or GENERIC_WRITE, NULL, NULL, \
	 OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0

	mov hFile, eax		;save handle to file (assumes success)

	;---- create file mapping object (sounds very C like)
	invoke CreateFileMapping, hFile, NULL, PAGE_READWRITE, 0, 0, NULL

	mov hMapObject, eax	;save handle to file map object (assumes success)

	;---- Create map VIEW of file (bytes in memory)
	invoke  MapViewOfFile, hMapObject, FILE_MAP_WRITE, 0, 0, 0

	mov pMapView, eax	;pointer to start of bytes in memory (assumes success)


;-----------------------------------------------------------------------------
;--- pMapView is now a pointer to the entire contents of the file in memory---
;--- any changes made to the data will be written to disk once the map view---
;--- of the file is un-mapped (MS lingo...clear as mud)                    ---
;-----------------------------------------------------------------------------
	

	mov dword ptr [eax], "edud"	;some text changed....hey, that's me!
	
;============================================================================
;=================================== Close  file ============================
;============================================================================

	;---- Unmap view of file - Windows will 'lazily' write changes to disk
	invoke UnmapViewOfFile, pMapView

	;---- Close handle to file mapping object (again with the C lingo)
	invoke CloseHandle, hMapObject

	;---- Close handle to file (on disk)
	invoke CloseHandle, hFile

	invoke ExitProcess, NULL


MapaFile endp

end MapaFile